package com.fp.persistence.pgeneral.gene;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TGENETELLERTRANSFERDETAIL*/
@Embeddable
public class TgeneTellerTransferDetailKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="USERCODE", nullable=false,updatable=false)

/**
* Codigo de usuario que origina la transferencia
*/
private String usercode;

@Column(name="WORKINGDATE", nullable=false,updatable=false)

/**
* Fecha de trabajo en la cual se origina la transferencia
*/
private Date workingdate;

@Column(name="TRANSFERNUMBER", nullable=false,updatable=false)

/**
* Secuencia de transferencia para el usuaio fecha de trabajo
*/
private Integer transfernumber;

@Column(name="CATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String catalog;

@Column(name="CATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String catalogcode;

@Column(name="DENOMINATIONVALUE", nullable=false,updatable=false)

/**
* Valor de la denominacion, ejemplo billetes de 100, 50, 20,10 etc
*/
private BigDecimal denominationvalue;

/**Contructor por defecto*/
public TgeneTellerTransferDetailKey(){}
/**Contructor de TgeneTellerTransferDetailKey
@param pUsercode Codigo de usuario que origina la transferencia
@param pWorkingdate Fecha de trabajo en la cual se origina la transferencia
@param pTransfernumber Secuencia de transferencia para el usuaio fecha de trabajo
@param pCatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pCatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
@param pDenominationvalue Valor de la denominacion, ejemplo billetes de 100, 50, 20,10 etc
*/
public TgeneTellerTransferDetailKey(String pUsercode,Date pWorkingdate,Integer pTransfernumber,String pCatalog,String pCatalogcode,BigDecimal pDenominationvalue){
 usercode=pUsercode;
 workingdate=pWorkingdate;
 transfernumber=pTransfernumber;
 catalog=pCatalog;
 catalogcode=pCatalogcode;
 denominationvalue=pDenominationvalue;
}
/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de workingdate
@return valor de workingdate*/
public Date getWorkingdate(){
  return workingdate;
}
/**Fija el valor de workingdate
@param pWorkingdate nuevo Valor de workingdate*/
public void setWorkingdate(Date pWorkingdate){
  workingdate=pWorkingdate;
}

/**Obtiene el valor de transfernumber
@return valor de transfernumber*/
public Integer getTransfernumber(){
  return transfernumber;
}
/**Fija el valor de transfernumber
@param pTransfernumber nuevo Valor de transfernumber*/
public void setTransfernumber(Integer pTransfernumber){
  transfernumber=pTransfernumber;
}

/**Obtiene el valor de catalog
@return valor de catalog*/
public String getCatalog(){
  return catalog;
}
/**Fija el valor de catalog
@param pCatalog nuevo Valor de catalog*/
public void setCatalog(String pCatalog){
  catalog=pCatalog;
}

/**Obtiene el valor de catalogcode
@return valor de catalogcode*/
public String getCatalogcode(){
  return catalogcode;
}
/**Fija el valor de catalogcode
@param pCatalogcode nuevo Valor de catalogcode*/
public void setCatalogcode(String pCatalogcode){
  catalogcode=pCatalogcode;
}

/**Obtiene el valor de denominationvalue
@return valor de denominationvalue*/
public BigDecimal getDenominationvalue(){
  return denominationvalue;
}
/**Fija el valor de denominationvalue
@param pDenominationvalue nuevo Valor de denominationvalue*/
public void setDenominationvalue(BigDecimal pDenominationvalue){
  denominationvalue=pDenominationvalue;
}

/**Implementación de la comparación de TgeneTellerTransferDetailKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneTellerTransferDetailKey))return false;
  TgeneTellerTransferDetailKey that = (TgeneTellerTransferDetailKey) o;
  if (this.getUsercode() == null || that.getUsercode() == null){
      return false;
  }
  if (! this.getUsercode().equals(that.getUsercode())){
    return false;
  }
  if (this.getWorkingdate() == null || that.getWorkingdate() == null){
      return false;
  }
  if (! this.getWorkingdate().equals(that.getWorkingdate())){
    return false;
  }
  if (this.getTransfernumber() == null || that.getTransfernumber() == null){
      return false;
  }
  if (! this.getTransfernumber().equals(that.getTransfernumber())){
    return false;
  }
  if (this.getCatalog() == null || that.getCatalog() == null){
      return false;
  }
  if (! this.getCatalog().equals(that.getCatalog())){
    return false;
  }
  if (this.getCatalogcode() == null || that.getCatalogcode() == null){
      return false;
  }
  if (! this.getCatalogcode().equals(that.getCatalogcode())){
    return false;
  }
  if (this.getDenominationvalue() == null || that.getDenominationvalue() == null){
      return false;
  }
  if (! this.getDenominationvalue().equals(that.getDenominationvalue())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneTellerTransferDetailKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getUsercode() == null ? 0 : this.getUsercode().hashCode());
    result = result * 37 + (this.getWorkingdate() == null ? 0 : this.getWorkingdate().hashCode());
    result = result * 37 + (this.getTransfernumber() == null ? 0 : this.getTransfernumber().hashCode());
    result = result * 37 + (this.getCatalog() == null ? 0 : this.getCatalog().hashCode());
    result = result * 37 + (this.getCatalogcode() == null ? 0 : this.getCatalogcode().hashCode());
    result = result * 37 + (this.getDenominationvalue() == null ? 0 : this.getDenominationvalue().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
